using System;
using Dll_CSharp_VSensorLaser;
using System.Collections.Generic;
using System.Threading;
namespace Demo.ExternalTrigger
{
    public class Program
    {
        static void Main(string[] args)
        {
            try
            {
                //获取相对路径
                string path = System.IO.Directory.GetCurrentDirectory();
                //实例化设备
                VSensorLaserDLL VSensor = new VSensorLaserDLL();
                //获取设备列表
                List<VSensorLaserCameraInfoCLR> list = new List<VSensorLaserCameraInfoCLR>(20);
                for (int i = 0; i < 20; i++)
                {
                    list.Add(new VSensorLaserCameraInfoCLR());
                }
                int num = 0;
                VSensor.GetDeviceList(ref list, ref num);
                for (int i = 0; i < num; i++)
                {
                    Console.WriteLine("device num {0} : list[{1}] = {2}\n", i, i, list[i].CameraName);
                }
                //连接第一台设备
                int status = VSensor.DeviceConnect(0);
                if (status != 0)
                {
                    Console.WriteLine("connect device failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置曝光时间
                status = VSensor.SetExposureTime(2.0);
                if (status != 0)
                {
                    Console.WriteLine("set exposure time failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置投影等级
                status = VSensor.SetProjectLight(1);
                if (status != 0)
                {
                    Console.WriteLine("set project light failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置为采集模式
                status = VSensor.SetCaptureMode(2);
                if (status != 0)
                {
                    Console.WriteLine("set capture mode failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置缓存区大小
                status = VSensor.SetCloudBufferNum(10);
                if (status != 0)
                {
                    Console.WriteLine("set cloud buffer num failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //预留时间进行硬件触发采集
                Console.WriteLine("wait external trigger...\n");
                Thread.Sleep(5000);
                //获取缓存区触发的点云
                Console.WriteLine("get cloud buffer...\n");
                int width = 0;
                int height = 0;
                VSensor.GetImageResolution(ref width, ref height);
                List<VSensorLaserResultCLR> resultList = new List<VSensorLaserResultCLR>(10);
                for (int i = 0; i < 10; i++)
                {
                    resultList.Add(new VSensorLaserResultCLR(width, height));
                }
                int resultNum = 0;
                VSensor.GetCloudBuffer(ref resultList, ref resultNum);
                if (status != 0)
                {
                    Console.WriteLine("get cloud buffer failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                else
                {
                    Console.WriteLine("getted {0} frames of data\n", resultNum);
                    //保存点云为ply格式
                    for (int i = 0; i < resultNum; i++)
                    {
                        string varString = Convert.ToString(i);
                        string str = path + @"\test" + varString + ".ply";
                        status = VSensor.Save3DCloud(str, resultList[i], 0);
                        if (status != 0)
                        {
                            Console.WriteLine("save 3D points failed, status = {0}\n", status);
                            Console.ReadLine();
                        }
                    }
                }
                //反初始化设备
                status = VSensor.DeviceUnInit();
                if (status != 0)
                {
                    Console.WriteLine("device release failed, status = {0}\n", status);
                    Console.ReadLine();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine($"ex:{ex}");
            }
            Console.WriteLine("run success");
            Console.ReadLine();
            Console.ReadKey();
        }
    }
}
